//*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#* IoConfigCodes.h *#*#*#*#*#*#*#* (C) 2011-2016 DekTec
//
// Common driver - IO config codes get functions.
//

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- License -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.

// Copyright (C) 2011-2016 DekTec Digital Video B.V.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//  1. Redistributions of source code must retain the above copyright notice, this list
//     of conditions and the following disclaimer.
//  2. Redistributions in binary format must reproduce the above copyright notice, this
//     list of conditions and the following disclaimer in the documentation.
//
// THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
// INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
// PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL DEKTEC DIGITAL VIDEO BV, ITS AGENTS OR ITS EMPLOYEES BE LIABLE FOR
// ANY DIRECT, INDIRECT, CONSEQUENTIAL, INCIDENTAL, OR OTHER DAMAGES (INCLUDING DAMAGES
// FOR THE LOSS OF USE, INFORMATION, GOODWILL, PROFIT, WORK STOPPAGE, DATA, BUSINESS OR
// REVENUE) UNDER ANY CIRCUMSTANCES, OR UNDER ANY LEGAL THEORY, WHETHER IN CONTRACT, IN
// TORT, IN NEGLIGENCE, OR OTHERWISE, ARISING FROM THE USE OF, OR INABILITY TO USE THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

#ifndef __IOCONFIGCODES_H
#define __IOCONFIGCODES_H

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Type definitions -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-

// Type to store a single config code
typedef struct _IoConfigCode
{
    char*  m_pName;
    Int    m_Value;
} IoConfigCode;

// Type to store a set of config codes whos names result in the same hash
typedef struct _IoConfigCodeHashSet
{
    const IoConfigCode*  m_pConfigCodes;
    UInt  m_ConfigCodeCount;
} IoConfigCodeHashSet;

// Type to store all config codes
typedef struct _IoConfigCodeStore {
    const IoConfigCodeHashSet*  m_pConfigCodeHashSets;
    UInt  m_ConfigHashSetCount;
} IoConfigCodeStore;

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Public functions -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
DtStatus  IoConfigCodeGet(const char* pName, Int* pConfigCode);
DtStatus  IoConfigNameGet(Int  ConfigCode, char*  pName, Int Size);

#endif // __IOCONFIGCODES_H
